# FITPOL - Fit polynomial to file of pairs of numbers
# September 3, 2002
# By Doug Mink

procedure fitpol (infile)

file	infile		{prompt="File to fit"}
bool	debug=no	{prompt="Print debugging information (y or n)"}

begin
	char arg
	file templist	# File to which to write list of segments
	file xcout	# File to which to write xcsao output

	real x, y
	real sx, sy, sxy, sx2, sm, a0, a1

# Read pixels and shifts from xcout and find offset and stretch
	sx = 0.0
	sy = 0.0
	sxy = 0.0
	sx2 = 0.0
	sm = 0.0
	list = infile
	while (fscan (list, x, y) != EOF) {
		sx = sx + x
		sx2 = sx2 + (x * x)
		sxy = sxy + (x * y)
		sy = sy + y
		sm = sm + 1.0
		if (debug) {
		    print (sm," ", x, " ", y)
		    }
		}
	a0 = ((sy * sx2) - (sx * sxy)) / ((sm * sx2) - (sx * sx))
	a1 = ((sm * sxy) - (sx * sy)) / ((sm * sx2) - (sx * sx))
	print (a0," + x * ",a1)
end
